GreatWksText Class Reference

the main class to read the text part of GreatWorks Text file More...

`#include <GreatWksText.hxx>`

## Public Member Functions

| GreatWksText (GreatWksDocument &document)
| constructor
virtual | ~GreatWksText ()
| destructor
int | version () const
| returns the file version
int | numPages () const
| returns the number of pages

## Protected Member Functions

bool | createZones (int expectedHF)
| finds the different objects zones
bool | sendMainText ()
| send a main zone
int | numHFZones () const
| return the number of header/footer zones
bool | sendHF (int id)
| try to send the i^th header/footer
bool | canSendTextBoxAsGraphic (MWAWEntry const &entry)
| check if a textbox can be send in a graphic zone, ie. does not contains any graphic
bool | sendTextbox (MWAWEntry const &entry, MWAWListenerPtr listener=MWAWListenerPtr())
| try to send the textbox text
void | flushExtra ()
| sends the data which have not yet been sent to the listener
int | getFontId (int fileId) const
| read the final font id corresponding to a file id
bool | readFontNames ()
| try to read the font names zone
bool | readZone (GreatWksTextInternal::Zone &zone)
| try to read a zone ( textheader+fonts+rulers)
bool | readZonePositions (GreatWksTextInternal::Zone &zone)
| try to read the end of a zone ( line + frame position )
bool | sendZone (GreatWksTextInternal::Zone const &zone, MWAWListenerPtr listener=MWAWListenerPtr())
| try to send a zone
bool | sendSimpleTextbox (MWAWEntry const &entry, MWAWListenerPtr listener=MWAWListenerPtr())
| try to send simplified textbox zone
bool | readFont (MWAWFont &font)
| try to read a font
bool | readRuler (MWAWParagraph &para)
| try to read a ruler
bool | readToken (GreatWksTextInternal::Token &token, long &nChar)
| try to read a token
bool | findNextZone ()
| heuristic function used to find the next zone

## Protected Attributes

GreatWksDocument & | m_document
| the document
MWAWParserStatePtr | m_parserState
| the parser state
std::shared_ptr< GreatWksTextInternal::State > | m_state
| the state
MWAWParser * | m_mainParser
| the main parser;

## Private Member Functions

| GreatWksText (GreatWksText const &orig)=delete
GreatWksText & | operator= (GreatWksText const &orig)=delete

## Friends

class | GreatWksDocument
class | GreatWksParser
class | GreatWksDBParser
class | GreatWksDRParser
class | GreatWksSSParser

## Detailed Description

the main class to read the text part of GreatWorks Text file

## Constructor & Destructor Documentation

## GreatWksText() [1/2]

GreatWksText::GreatWksText | ( | GreatWksDocument & | document | ) |

explicit

constructor

Referenced by GreatWksText(), and operator=().

## ~GreatWksText()

GreatWksText::~GreatWksText | ( |  | ) |

virtual

destructor

## GreatWksText() [2/2]

GreatWksText::GreatWksText | ( | GreatWksText const & | orig | ) |

private delete

## Member Function Documentation

## canSendTextBoxAsGraphic()

bool GreatWksText::canSendTextBoxAsGraphic | ( | MWAWEntry const & | entry | ) |

protected

check if a textbox can be send in a graphic zone, ie. does not contains any graphic

## createZones()

bool GreatWksText::createZones | ( | int | expectedHF | ) |

protected

finds the different objects zones

## findNextZone()

bool GreatWksText::findNextZone | ( |  | ) |

protected

heuristic function used to find the next zone

Referenced by createZones().

## flushExtra()

void GreatWksText::flushExtra | ( |  | ) |

protected

sends the data which have not yet been sent to the listener

## getFontId()

int GreatWksText::getFontId | ( | int | fileId | ) | const

protected

read the final font id corresponding to a file id

## numHFZones()

int GreatWksText::numHFZones | ( |  | ) | const

protected

return the number of header/footer zones

## numPages()

int GreatWksText::numPages | ( |  | ) | const

returns the number of pages

## operator=()

GreatWksText & GreatWksText::operator= | ( | GreatWksText const & | orig | ) |

private delete

## readFont()

bool GreatWksText::readFont | ( | MWAWFont & | font | ) |

protected

try to read a font

Referenced by readZone().

## readFontNames()

bool GreatWksText::readFontNames | ( |  | ) |

protected

try to read the font names zone

Referenced by createZones().

## readRuler()

bool GreatWksText::readRuler | ( | MWAWParagraph & | para | ) |

protected

try to read a ruler

Referenced by readZone().

## readToken()

bool GreatWksText::readToken | ( | GreatWksTextInternal::Token & | token,
|  | long & | nChar )

protected

try to read a token

Referenced by readZone().

## readZone()

bool GreatWksText::readZone | ( | GreatWksTextInternal::Zone & | zone | ) |

protected

try to read a zone ( textheader+fonts+rulers)

Referenced by canSendTextBoxAsGraphic(), createZones(), findNextZone(), and sendTextbox().

## readZonePositions()

bool GreatWksText::readZonePositions | ( | GreatWksTextInternal::Zone & | zone | ) |

protected

try to read the end of a zone ( line + frame position )

Referenced by readZone().

## sendHF()

bool GreatWksText::sendHF | ( | int | id | ) |

protected

try to send the i^th header/footer

## sendMainText()

bool GreatWksText::sendMainText | ( |  | ) |

protected

send a main zone

## sendSimpleTextbox()

bool GreatWksText::sendSimpleTextbox | ( | MWAWEntry const & | entry,
|  | MWAWListenerPtr | listener = MWAWListenerPtr() )

protected

try to send simplified textbox zone

Referenced by sendTextbox().

## sendTextbox()

bool GreatWksText::sendTextbox | ( | MWAWEntry const & | entry,
|  | MWAWListenerPtr | listener = MWAWListenerPtr() )

protected

try to send the textbox text

## sendZone()

bool GreatWksText::sendZone | ( | GreatWksTextInternal::Zone const & | zone,
|  | MWAWListenerPtr | listener = MWAWListenerPtr() )

protected

try to send a zone

Referenced by flushExtra(), sendHF(), sendMainText(), and sendTextbox().

## version()

int GreatWksText::version | ( |  | ) | const

returns the file version

## Friends And Related Symbol Documentation

## GreatWksDBParser

friend class GreatWksDBParser

friend

Referenced by GreatWksDBParser.

## GreatWksDocument

friend class GreatWksDocument

friend

Referenced by GreatWksDocument, GreatWksSSParser, and GreatWksText().

## GreatWksDRParser

friend class GreatWksDRParser

friend

Referenced by GreatWksDRParser.

## GreatWksParser

friend class GreatWksParser

friend

Referenced by GreatWksParser.

## GreatWksSSParser

friend class GreatWksSSParser

friend

Referenced by GreatWksSSParser.

## Member Data Documentation

## m_document

GreatWksDocument& GreatWksText::m_document

protected

the document

Referenced by GreatWksText(), and sendZone().

## m_mainParser

MWAWParser* GreatWksText::m_mainParser

protected

the main parser;

Referenced by GreatWksText().

## m_parserState

MWAWParserStatePtr GreatWksText::m_parserState

protected

the parser state

Referenced by canSendTextBoxAsGraphic(), createZones(), findNextZone(), flushExtra(), GreatWksText(), readFont(), readFontNames(), readRuler(), readToken(), readZone(), readZonePositions(), sendSimpleTextbox(), sendTextbox(), sendZone(), and version().

## m_state

std::shared_ptr<GreatWksTextInternal::State> GreatWksText::m_state

protected

the state

Referenced by createZones(), flushExtra(), getFontId(), GreatWksText(), numHFZones(), numPages(), readFont(), readFontNames(), sendHF(), sendMainText(), sendSimpleTextbox(), and version().

The documentation for this class was generated from the following files:

- GreatWksText.hxx
- GreatWksText.cxx